# A hands-on tour of some new 3D elements

These materials are from a [short workshop](https://jsxgraph.org/conf2024/program/fenyes/) at the 2024 International JSXGraph Conference. You can watch a [video](https://www.youtube.com/watch?v=gwc0BrLjuiI) of the workshop to learn more about how they were used. If you want to see what the templates look like in a browser without downloading them, you can see them [on the web](https://ooo.fareycircles.ooo/writing/jsxgraph-3d-workshop/) or on JSFiddle.

## Templates

The files in the [`templates`](templates) folder show various ways of creating and styling the 3D elements that were added to JSXGraph in the summer of 2024. You can use them as starting points for your own explorations. Download the template files (or edit the JSFiddle versions online) and play with the the code in the `script` tags. The code is designed to be easy to copy and change—not to be concise or efficient.

* [Sphere sampler](templates/sphere-sampler.html) ([JSFiddle](https://jsfiddle.net/fareycircles/f05893by/))
* [Circle sampler](templates/circle-sampler.html) ([JSFiddle](https://jsfiddle.net/fareycircles/kv5g38oy/))
* [Polygon sampler](templates/polygon-sampler.html) ([JSFiddle](https://jsfiddle.net/fareycircles/4s9f7wxe/))
* [Intersection sampler](templates/intersection-sampler.html) ([JSFiddle](https://jsfiddle.net/fareycircles/4xztkbLo/))
* [Glider sampler](templates/glider-sampler.html) ([JSFiddle](https://jsfiddle.net/fareycircles/f71wgvs2/))
* [View options demo](templates/view-demo.html) ([JSFiddle](https://jsfiddle.net/fareycircles/omkqe9pw/))

## Challenges

If you need some inspiration to help you practice with the new 3D elements, try to recreate scenes in the [`challenges`](challenges) folder without looking at the source code. You don't need to make your versions look exactly the same, or even close to the same; these are just to get you thinking.

* [Sphere contours](challenges/sphere-contours.html)
* [Octahedron](challenges/octahedron.html)

## Background

These new JSXGraph elements and capabilities were developed thanks to the fiscal sponsorship of the [Seattle Universal Math Museum](https://seattlemathmuseum.org). They were motivated by the [archematics](https://archematics.app) project: an effort to preserve interactive visualizations made with David Joyce’s [Geometry Applet](http://aleph0.clarku.edu/~djoyce/java/elements/elements.html). When archematics is ready for public release, it will hopefully be built on JSXGraph.

After the workshop, Alfred Wassermann remarked that the Geometry Applet was one of JSXGraph’s original inspirations. It’s nice to look forward to JSXGraph coming full circle and helping preserve the software that influenced its development.